
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>

#include "read_command.h"
#include "wait.h"

void print_prompt() {
  printf("myshell> ");
}

void execute_command() {
  execvp(tokens[0], tokens);
  // se siamo qui la execlp ha fallito!
  perror(line);
}

void wait_for_child() {
  int status;
  wait(&status);
  printf("child returned with status %d\n", status);
}

int command_is_empty() {
  return num_tokens == 0;
}

int main() {
  while (1) {
    wait_for_terminated_children();
    print_prompt();
    read_command();
    tokenize_command();
    if (command_is_empty()) {
      continue;
    }
    pid_t pid = fork();
    if (0 == pid) {
      execute_command();
    } else {
      if (command_is_in_foreground()) {
        wait_for_child();
      }
    }
  }
}
